<html>
    <head>
            <title>Artikel 7 AOW, Clingo WASM runner</title>
    </head>
    <body>
        <h4>Clingo output:</h4>
        <pre id="output"></pre>
        <hl/>
        <h4>source:</h4>
        <pre id="source"></pre>
        <script src="https://cdn.jsdelivr.net/npm/clingo-wasm@0.1.1/dist/clingo.web.min.js"></script>
        <script>
            async function main(lpsrc) {
                output = document.getElementById("output");
                await clingo.init("https://cdn.jsdelivr.net/npm/clingo-wasm@0.1.1/dist/clingo.wasm");
                tmp = await clingo.run(lpsrc);
                output.textContent = JSON.stringify(tmp, undefined, 2);
            }

            lpsrc = `
% note: comments have been stripped
pgl(J, PGLJ, PGLM) :- pgl(J+1, PGLJ, PGLM), J < 2013, J > 1900.
pgl(
  2013, 65, 0;
  2014, 65, 1;
  2015, 67, 2;
  2016, 66, 1;
).
pgl(J, PGLJ, PGLM) :- pgl(J-1, PGLJ, PGLM), J > 2016, J < 2100.
pgl(J, PGL) :- pgl(J, PGJ, PGM), PGL = (PGJ*12) + PGM - 1.
pgl_in_jaar_maand(P, JM) :- person(P), pgl(J, PGL), leeftijd(P, JM, L), J = JM / 12, L >= PGL.
heeft_bereikt(P, MINJM) :- pgl_in_jaar_maand(P, JM), MINJM = #min{JM1 : pgl_in_jaar_maand(P1, JM1)}, P = P1.
leeftijd(P, JM+1, L+1) :- person(P), leeftijd(P, JM, L), JM > 1900*12, JM < 2100*12.
geboren(P, J, M) :- geboren(P, D, M, J).
leeftijd(P, J, M, 0) :- person(P), geboren(P, J, M).
leeftijd(P, JM, L) :- leeftijd(P, J, M, L), JM = (J*12) + M.
heeft_bereikt(P, J, M+1) :- heeft_bereikt(P, JM), M = (JM \\ 12), J = (JM / 12).
heeft_bereikt(P, DG, M, J) :- heeft_bereikt(P, J, M), geboren(P, DG, MG, JG), DG <= 28.
heeft_bereikt(P, 29, M, J) :- heeft_bereikt(P, J, M), geboren(P, DG, MG, JG), DG >= 29, M=2, (J \\ 4) = 0.
heeft_bereikt(P, 28, M, J) :- heeft_bereikt(P, J, M), geboren(P, DG, MG, JG), DG > 28, M=2, (J \\ 4) != 0.
heeft_bereikt(P, DG, M, J) :- heeft_bereikt(P, J, M), geboren(P, DG, MG, JG), DG >= 29, DG <= 31, (M \\ 2) = 0, M >= 8.
heeft_bereikt(P, DG, M, J) :- heeft_bereikt(P, J, M), geboren(P, DG, MG, JG), DG >= 29, DG <= 31, (M \\ 2) = 1, M < 8.
person(bas).
geboren(bas, 26, 11, 1983).
:- not heeft_bereikt(bas, 26, 12, 2049).
person(peter).
geboren(peter, 31, 1, 1949).
:- not heeft_bereikt(peter, 28, 2, 2014).
#show heeft_bereikt/4.
`;
            document.getElementById("source").innerText = lpsrc;
            main(lpsrc);
        </script>
    </body>
</html>
